diff --git a/build.gradle.kts b/build.gradle.kts
index 39f707195..939b23104 100644
--- a/build.gradle.kts
+++ b/build.gradle.kts
@@ -10,7 +10,7 @@ plugins {
 }
 
 group = "net.minecraft"
-version = "7.2"
+version = "7.2 Prerelease 1"
 val buildChannel = "PRERELEASE"
 
 run {
diff --git a/src/common/resources/lang/en_US/item.lang b/src/common/resources/lang/en_US/item.lang
index 8c5c11543..3f8f8fc72 100644
--- a/src/common/resources/lang/en_US/item.lang
+++ b/src/common/resources/lang/en_US/item.lang
@@ -411,9 +411,6 @@ item.door.oak.painted.white.desc=Every house needs one.
 item.door.glass.name=Glass Door
 item.door.glass.desc=Great for aesthetics, terrible for privacy.
 
-item.door.glass.tinted.name=Tinted Glass Door
-item.door.glass.tinted.desc=Okay for aesthetics, okay for privacy.
-
 item.rope.name=Rope
 item.rope.desc=Strong enough to climb.
 
diff --git a/src/common/resources/lang/en_US/options.lang b/src/common/resources/lang/en_US/options.lang
index 8e933da01..416cee6b3 100644
--- a/src/common/resources/lang/en_US/options.lang
+++ b/src/common/resources/lang/en_US/options.lang
@@ -219,5 +219,4 @@ key.sprint=Sprint (if enabled)
 key.toggleDebug=Toggle Debug
 key.toggleOverlay=Toggle Overlays
 key.sortInventory=Sort Inventory
-key.pickAmmo=Pick Ammo
 key.disabled=Disabled
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 59e147c3b..026e55214 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -8,8 +8,6 @@ import java.io.IOException;
 import java.util.ArrayList;
 import java.util.Random;
 
-import net.minecraft.client.gui.hud.AmmoPickerComponent;
-import net.minecraft.client.gui.hud.HudComponents;
 import org.lwjgl.LWJGLException;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
@@ -228,6 +226,7 @@ public class Minecraft
      * Do not display the ingame crash handler until this is set to true
      */
     private boolean gameStarted = false;
+    private int mojrand = new Random(System.currentTimeMillis()).nextInt(200);
     
     public Minecraft(GameWindow gameWindow)
     {
@@ -555,8 +554,7 @@ public class Minecraft
         glEnable(3553 /*GL_TEXTURE_2D*/);
         glDisable(2912 /*GL_FOG*/);
         
-        Random mojrand = new Random();
-        if(mojrand.nextInt(200) == 0)
+        if(mojrand == 0)
             glBindTexture(3553 /*GL_TEXTURE_2D*/, renderEngine.getTexture("/title/majonk.png"));
         else
             glBindTexture(3553 /*GL_TEXTURE_2D*/, renderEngine.getTexture("/title/mojang.png"));
@@ -1277,10 +1275,7 @@ public class Minecraft
                         	thePlayer.setFlySpeed(newSpeed);
                         	ingameGUI.guiHeldItemTooltip.setOptionNameAndValueString(gameSettings.flightSpeed);
                         }
-                        else if (gameSettings.keyPickAmmo.isPressed()) {
-                            thePlayer.pickAmmo(scrollDelta);
-                        }
-                        else if (!gameSettings.keyZoom.isPressed() && !gameSettings.keyPickAmmo.isPressed())
+                        else if (!gameSettings.keyZoom.isPressed())
                         {
                             thePlayer.inventory.changeCurrentItem(scrollDelta);
                         }
@@ -1488,10 +1483,6 @@ public class Minecraft
                 }
             }
 
-            if (gameSettings.keyPickAmmo.isPressed()) {
-                ((AmmoPickerComponent) HudComponents.AMMO_PICKER).show();
-            }
-
             boolean breakBlockPressed = gameSettings.keyAttack.isPressed() || (controllerInput != null && controllerInput.buttonZR.isPressed());
             boolean placeBlockPressed = gameSettings.keyInteract.isPressed() || (controllerInput != null && controllerInput.buttonZL.isPressed());
 
@@ -2085,7 +2076,9 @@ public class Minecraft
             loadingScreen.progressStop();
         }
         worldRenderer.lightmapHelper.setup();
-        Colorizers.update(true);
+        if(theWorld != null) {
+        	Colorizers.update(true);	
+        }
     }
 
     private void convertSaveVersion(int fromVersion, String worldDirName, String worldName)
diff --git a/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java b/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
index 89503edee..a250cf302 100644
--- a/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
+++ b/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
@@ -33,8 +33,6 @@ import net.minecraft.core.block.entity.TileEntityTrommel;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.item.IAmmoPickable;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.ClientCommandHandler;
 import net.minecraft.core.net.command.ClientPlayerCommandSender;
@@ -398,28 +396,6 @@ public class EntityPlayerSP extends EntityPlayer
         	messageHistory.remove(0);
         }
     }
-
-    public void pickAmmo(int offset) {
-        if (offset == 0) return;
-        if (offset < 0) offset = -1;
-        if (offset > 0) offset = 1;
-
-        ItemStack stack = mc.thePlayer.getHeldItem();
-        if (stack == null) return;
-
-        Item item = stack.getItem();
-        if (!(item instanceof IAmmoPickable)) return;
-
-        IAmmoPickable pickable = (IAmmoPickable) item;
-        List<ItemStack> ammoTypes = pickable.getPresentAmmoTypes(this);
-
-        int pickedIndex = ammoTypes.indexOf(pickable.getPickedAmmoType(stack));
-        int newIndex = pickedIndex + offset;
-        if (newIndex < 0) newIndex = ammoTypes.size() - 1;
-        if (newIndex >= ammoTypes.size()) newIndex = 0;
-
-        pickable.setPickedAmmoType(stack, ammoTypes.get(newIndex));
-    }
     
     @Override
     public boolean isSneaking()
diff --git a/src/main/java/net/minecraft/client/gui/GuiSelectWorld.java b/src/main/java/net/minecraft/client/gui/GuiSelectWorld.java
index 8e8bdf468..78f3237d0 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSelectWorld.java
+++ b/src/main/java/net/minecraft/client/gui/GuiSelectWorld.java
@@ -2,17 +2,25 @@ package net.minecraft.client.gui;
 
 import net.minecraft.client.gui.popup.GuiPopup;
 import net.minecraft.client.gui.popup.PopupBuilder;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.client.player.controller.PlayerControllerSP;
+import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.SaveFile;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.type.WorldType;
 import org.lwjgl.input.Keyboard;
 
+import java.security.Key;
 import java.text.DateFormat;
 import java.text.SimpleDateFormat;
 import java.util.Collections;
+import java.util.Date;
 import java.util.List;
 
 public class GuiSelectWorld extends GuiScreen
@@ -50,10 +58,27 @@ public class GuiSelectWorld extends GuiScreen
             stringConversion = i18n.translateKey("gui.select_world.label.outdated");
         }
         loadSaves();
-        worldSlotContainer = new GuiWorldSlot(this);
+        worldSlotContainer = new GuiWorldSlot();
         initButtons();
     }
 
+    @Override
+    public void keyTyped(char c, int key, int mouseX, int mouseY) {
+        if (key == Keyboard.KEY_UP) {
+            if (selectedWorld > 0) {
+                worldSlotContainer.selectItem(selectedWorld - 1, false);
+            }
+        }
+        if (key == Keyboard.KEY_DOWN) {
+            if (selectedWorld < saveList.size() - 1) {
+                worldSlotContainer.selectItem(selectedWorld + 1, false);
+            }
+        }
+        if (key == Keyboard.KEY_DELETE) {
+            tryDeleteWorld(Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT));
+        }
+    }
+
     private void loadSaves()
     {
         ISaveFormat isaveformat = mc.getSaveFormat();
@@ -108,6 +133,36 @@ public class GuiSelectWorld extends GuiScreen
         }
     }
 
+    void tryDeleteWorld(boolean skipConfirm) {
+        if (selectedWorld < 0 || selectedWorld >= saveList.size()) return;
+        String s = getSaveName(selectedWorld);
+        if(s != null)
+        {
+            deleting = true;
+            if (skipConfirm) {
+                deleteWorld(true, selectedWorld);
+            } else {
+                I18n i18n = I18n.getInstance();
+                GuiPopup popup = new PopupBuilder(this, 250)
+                    .closeOnEsc(0)
+                    .withLabel("gui.select_world.label.delete_title")
+                    .withLabel("gui.select_world.label.delete_confirm.1")
+                    .withLabelLiteral(i18n.translateKeyAndFormat("gui.select_world.label.delete_confirm.2", s))
+                    .withLabelLiteral("")
+                    .withButtonGroup("endButtons", new String[] { "gui.select_world.button.delete", "gui.select_world.button.cancel" }, new int[] { 1, 0 })
+                    .withOnCloseListener((statusCode, results) -> {
+                        if (statusCode == 1)
+                        {
+                            deleteWorld(true, selectedWorld);
+                        }
+                    })
+                    .build();
+                mc.displayGuiScreen(popup);
+            }
+        }
+
+    }
+
     @Override
     protected void buttonPressed(GuiButton button)
     {
@@ -117,31 +172,7 @@ public class GuiSelectWorld extends GuiScreen
         }
         if(button.id == 2)
         {
-            String s = getSaveName(selectedWorld);
-            if(s != null)
-            {
-                deleting = true;
-                if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT)) {
-                    deleteWorld(true, selectedWorld);
-                } else {
-                    I18n i18n = I18n.getInstance();
-                    GuiPopup popup = new PopupBuilder(this, 250)
-                        .closeOnEsc(0)
-                        .withLabel("gui.select_world.label.delete_title")
-                        .withLabel("gui.select_world.label.delete_confirm.1")
-                        .withLabelLiteral(i18n.translateKeyAndFormat("gui.select_world.label.delete_confirm.2", s))
-                        .withLabelLiteral("")
-                        .withButtonGroup("endButtons", new String[] { "gui.select_world.button.delete", "gui.select_world.button.cancel" }, new int[] { 1, 0 })
-                        .withOnCloseListener((statusCode, results) -> {
-                            if (statusCode == 1)
-                            {
-                                deleteWorld(true, selectedWorld);
-                            }
-                        })
-                        .build();
-                    mc.displayGuiScreen(popup);
-                }
-            }
+            tryDeleteWorld(false);
         }
         else if(button.id == 1)
         {
@@ -181,7 +212,7 @@ public class GuiSelectWorld extends GuiScreen
 
     public void selectWorld(int i)
     {
-        SaveFile save = getSaveList(this).get(i);
+        SaveFile save = saveList.get(i);
         if (save.getNeedsConversion() && Global.DISABLE_OLD_WORLDS)
         {
             return;
@@ -228,48 +259,88 @@ public class GuiSelectWorld extends GuiScreen
         super.drawScreen(mouseX, mouseY, partialTick);
     }
 
-    static List<SaveFile> getSaveList(GuiSelectWorld gui)
-    {
-        return gui.saveList;
-    }
-
-    static int setSelectedWorld(GuiSelectWorld gui, int i)
+    class GuiWorldSlot extends ScrolledSelectionList
     {
-        return gui.selectedWorld = i;
-    }
+        public GuiWorldSlot()
+        {
+            super(mc, width, height, 32, height - 64, 36);
+        }
 
-    static int getSelectedWorld(GuiSelectWorld gui)
-    {
-        return gui.selectedWorld;
-    }
+        @Override
+        protected int getItemCount()
+        {
+            return saveList.size();
+        }
 
-    static GuiButton getSelectButton(GuiSelectWorld gui)
-    {
-        return gui.buttonSelect;
-    }
+        @Override
+        protected void selectItem(int itemIndex, boolean doubleClicked)
+        {
+            selectedWorld = itemIndex;
+            boolean flag1 = selectedWorld >= 0 && selectedWorld < getItemCount();
+            buttonSelect.enabled = flag1;
+            buttonRename.enabled = flag1;
+            buttonDelete.enabled = flag1;
+            if(doubleClicked && flag1)
+            {
+                selectWorld(itemIndex);
+            }
+        }
 
-    static GuiButton getRenameButton(GuiSelectWorld gui)
-    {
-        return gui.buttonRename;
-    }
+        @Override
+        protected boolean isSelectedItem(int itemIndex)
+        {
+            return itemIndex == selectedWorld;
+        }
 
-    static GuiButton getDeleteButton(GuiSelectWorld gui)
-    {
-        return gui.buttonDelete;
-    }
+        @Override
+        protected int getMaxPosition()
+        {
+            return saveList.size() * 36;
+        }
 
-    static String getStringWorld(GuiSelectWorld gui)
-    {
-        return gui.stringWorld;
-    }
+        @Override
+        protected void renderHoleBackground()
+        {
+            drawDefaultBackground();
+        }
 
-    static DateFormat getDateFormatter(GuiSelectWorld gui)
-    {
-        return gui.dateFormatter;
-    }
+        @Override
+        protected void renderItem(int index, int x, int y, int height, Tessellator tessellator)
+        {
+            I18n i18n = I18n.getInstance();
+            SaveFile saveFile = saveList.get(index);
+            String s = saveFile.getDisplayName();
+            if(s == null || MathHelper.stringNullOrLengthZero(s))
+            {
+                s = i18n.translateKeyAndFormat(stringWorld, index + 1);
+            }
+            String s1 = saveFile.getFileName();
+            s1 = s1 + " (" + dateFormatter.format(new Date(saveFile.getLastTimePlayed()));
+            long l1 = saveFile.getSizeOnDisk();
+            s1 = s1 + ", " + (float) (((l1 / 1024L) * 100L) / 1024L) / 100F + " MB)";
+            String s2 = "";
+            if(saveFile.getNeedsConversion())
+            {
+                s2 = stringConversion + " " + s2;
+            }
+            else
+            {
+                LevelData ld = saveFile.getLevelData();
+                DimensionData dd = saveFile.getDimensionData()[0];
+                I18n st = I18n.getInstance();
+                s2 += st.translateNameKey(Gamemode.gamemodesList[ld.getGamemode()].getLanguageKey());
+                if (ld.getCheatsEnabled()) s2 += " | " + st.translateKey("gui.select_world.label.cheats");
+                WorldType worldType = dd.getWorldType();
+                if (worldType != null) {
+                    s2 += " | " + st.translateNameKey(dd.getWorldType().getLanguageKey());
+                } else {
+                    s2 += " | " + TextFormatting.RED + st.translateKey("gui.select_world.label.unknown");
+                }
+            }
 
-    static String getStringConversion(GuiSelectWorld gui)
-    {
-        return gui.stringConversion;
+            drawString(fontRenderer, s, x + 2, y + 1, 0xffffff);
+            drawString(fontRenderer, s1, x + 2, y + 12, 0x808080);
+            drawString(fontRenderer, s2, x + 2, y + 12 + 10, 0x808080);
+        }
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/GuiSwitchButton.java b/src/main/java/net/minecraft/client/gui/GuiSwitchButton.java
index 17d69129c..bb5fcce88 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSwitchButton.java
+++ b/src/main/java/net/minecraft/client/gui/GuiSwitchButton.java
@@ -54,7 +54,7 @@ public class GuiSwitchButton
         FontRenderer fontrenderer = mc.fontRenderer;
         boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
         int state = getButtonState(mouseOver);
-        int xBar = on ? width / 3 : 0;
+        int xBar = on ? (width / 3) + 1 : 0;
 
         GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
diff --git a/src/main/java/net/minecraft/client/gui/hud/HudComponents.java b/src/main/java/net/minecraft/client/gui/hud/HudComponents.java
index 887514243..32bbb9f9b 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HudComponents.java
+++ b/src/main/java/net/minecraft/client/gui/hud/HudComponents.java
@@ -58,5 +58,4 @@ public class HudComponents {
     public static final HudComponent OXYGEN_BAR = register(new OxygenBarComponent("oxygen_bar", new SnapLayout(HEALTH_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
     public static final HudComponent FIRE_BAR = register(new FireBarComponent("fire_bar", new SnapLayout(OXYGEN_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
     public static final HudComponent ROTATION_LOCK = register(new RotationLockComponent("rotation_lock", new SnapLayout(CROSSHAIR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT)));
-    public static final HudComponent AMMO_PICKER = register(new AmmoPickerComponent("ammo_picker", new SnapLayout(CROSSHAIR, ComponentAnchor.CENTER_LEFT, ComponentAnchor.CENTER_RIGHT)));
 }
diff --git a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index c59d6a95a..67b2fcc20 100644
--- a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -150,7 +150,6 @@ public abstract class OptionsPages
             .withComponent(new KeyBindingComponent(mc.gameSettings.keyChat))
             .withComponent(new KeyBindingComponent(mc.gameSettings.keyCommand))
             .withComponent(new KeyBindingComponent(mc.gameSettings.keyGuidebook))
-            .withComponent(new KeyBindingComponent(mc.gameSettings.keyPickAmmo))
             .withComponent(new KeyBindingComponent(mc.gameSettings.keyShowRecipe))
             .withComponent(new KeyBindingComponent(mc.gameSettings.keyShowUsage))
             .withComponent(new KeyBindingComponent(mc.gameSettings.keyPlayerList))
diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index fdb789847..982b055f1 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -213,7 +213,6 @@ public class GameSettings {
 	public KeyBinding keySprint = new KeyBinding("key.sprint").bindKeyboard(KEY_NONE);
 	public KeyBinding keyToggleDebug = new KeyBinding("key.toggleDebug").bindKeyboard(KEY_F3);
 	public KeyBinding keyToggleOverlay = new KeyBinding("key.toggleOverlay").bindKeyboard(KEY_F4);
-	public KeyBinding keyPickAmmo = new KeyBinding("key.pickAmmo").bindKeyboard(KEY_LMENU);
 
 	public KeyBinding[] keys = ReflectUtils.getAllObjects(GameSettings.class, KeyBinding.class, this);
 
diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index d9dc38c07..b43167368 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -473,7 +473,7 @@ public class RenderBlocks
         } else
         if(uvRotateBottom == 3)
         {
-            d3 = tex.getSubIconU(1 - block.minX);
+            d3 = tex.getSubIconU(1 - block.maxX);
             d4 = tex.getSubIconU(1 - block.minX);
             d5 = tex.getSubIconV(1 - block.minZ);
             d6 = tex.getSubIconV(1 - block.maxZ);
diff --git a/src/main/java/net/minecraft/client/render/RenderEngine.java b/src/main/java/net/minecraft/client/render/RenderEngine.java
index b0eb10ab2..91c1467a0 100644
--- a/src/main/java/net/minecraft/client/render/RenderEngine.java
+++ b/src/main/java/net/minecraft/client/render/RenderEngine.java
@@ -718,6 +718,7 @@ public class RenderEngine {
 		mc.mainMenuBackground.refresh(errors);
 		
         Colorizers.reload();
+        Colorizers.update(true);
         
         mc.worldRenderer.lightmapHelper.setup();
 	}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index bf7c3ad7d..8598ae8a2 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -314,7 +314,6 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelTrapDoor<>(Block.trapdoorPlanksOak).withTextures("minecraft:block/trapdoor_planks_oak_top", "minecraft:block/trapdoor_planks_oak_side"));
         addDispatch(new BlockModelTrapDoor<>(Block.trapdoorIron).withTextures("minecraft:block/trapdoor_iron_top", "minecraft:block/trapdoor_iron_side"));
         addDispatch(new BlockModelTrapDoor<>(Block.trapdoorGlass).withTextures("minecraft:block/glass", "minecraft:block/trapdoor_glass_side"));
-        addDispatch(new BlockModelTrapDoor<>(Block.trapdoorGlassTinted).withTextures("minecraft:block/glass_tinted", "minecraft:block/trapdoor_glass_tinted_side"));
         addDispatch(new BlockModelTrapDoorPainted<>(Block.trapdoorPlanksOakPainted));
 
         addDispatch(new BlockModelStandard<>(Block.tnt).withTextures("minecraft:block/tnt_top", "minecraft:block/tnt_bottom", "minecraft:block/tnt_side"));
@@ -327,8 +326,6 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelDoorPainted<>(Block.doorPlanksOakPaintedTop, true).withTextures("minecraft:block/trapdoor_planks_oak_top", "minecraft:block/door_planks_oak_top"));
         addDispatch(new BlockModelDoorGlass<>(Block.doorGlassBottom).withTextures("minecraft:block/glass", "minecraft:block/door_glass_bottom"));
         addDispatch(new BlockModelDoorGlass<>(Block.doorGlassTop).withTextures("minecraft:block/glass", "minecraft:block/door_glass_top"));
-        addDispatch(new BlockModelDoorGlass<>(Block.doorGlassTintedBottom).withTextures("minecraft:block/glass_tinted", "minecraft:block/door_glass_tinted_bottom"));
-        addDispatch(new BlockModelDoorGlass<>(Block.doorGlassTintedTop).withTextures("minecraft:block/glass_tinted", "minecraft:block/door_glass_tinted_top"));
 
         addDispatch(new BlockModelTransparent<>(Block.mesh, true).withTextures("minecraft:block/mesh"));
         addDispatch(new BlockModelTransparent<>(Block.meshGold, true).withTextures("minecraft:block/mesh_gold"));
diff --git a/src/main/java/net/minecraft/client/render/colorizer/ColorMap.java b/src/main/java/net/minecraft/client/render/colorizer/ColorMap.java
index 3d7ff8b35..7680b14b8 100644
--- a/src/main/java/net/minecraft/client/render/colorizer/ColorMap.java
+++ b/src/main/java/net/minecraft/client/render/colorizer/ColorMap.java
@@ -4,12 +4,9 @@ import net.minecraft.core.util.helper.MathHelper;
 
 public class ColorMap {
 	
-	public final Colorizer colorizer;
 	public final int[] buffer = new int[0x10000];
 	
-	public ColorMap(Colorizer colorizer) {
-		this.colorizer = colorizer;
-		
+	public ColorMap() {
 		for(int i=0; i < buffer.length; i++) {
 			buffer[i] = 0xFFFFFFFF;
 		}
diff --git a/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java b/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
index 838a2588c..70a2fa749 100644
--- a/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
+++ b/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.render.colorizer;
 
-import java.util.HashMap;
 import java.util.List;
-import java.util.Map;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
@@ -14,66 +14,97 @@ public class Colorizer {
 	
 	public final String name;
 	
+	private final ColorMap currentColor = new ColorMap();
 	private ColorMap defaultColor;
-	private Map<Season, ColorMap> seasonalColormaps;
-	private ColorMap currentColor;
-	private boolean enabled = false;
+	private TexturePack texturePack;
 	
 	public Colorizer(String name) {
 		this.name = name;
 	}
 	
 	public void setup(Minecraft minecraft, List<Season> seasons) {
-		this.defaultColor = new ColorMap(this);
-		this.seasonalColormaps = new HashMap<>();
-		this.currentColor = new ColorMap(this);
-		
-		if(Colorizers.loadColorData(defaultColor, "default")) {
-			this.enabled = true;
-			for(int i=0; i < seasons.size(); i++) {
-				Season season = seasons.get(i);
-				if(season == Seasons.NULL) {
-					continue;
-				}
-				
-				String seasonName = season.getId().replace('.', '_');
-				ColorMap colorMap = new ColorMap(this);
-				
-				if(Colorizers.loadColorData(colorMap, seasonName)) {
-					this.seasonalColormaps.put(season, colorMap);
-				}
-			}
-		}else {
-			this.enabled = false;
+		texturePack = null;
+		if(minecraft.theWorld == null) {
+			return;
+		}
+		
+		String path = null;
+		
+		// First, check if there is a colormap for the current dimension
+		Dimension dimension = minecraft.theWorld.dimension;
+		String dimensionName = dimension.languageKey.replace('.', '_').toLowerCase();
+		path = "/assets/minecraft/textures/colormap/" + this.name + "/" + dimensionName + ".png";
+		texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
+		
+		if(texturePack == null) {
+			// If there is no colormap for the currrent dimension, check if there is a default colormap, to be used for all dimensions
+			path = "/assets/minecraft/textures/colormap/" + this.name + "/default.png";
+			texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
+		}
+		
+		// If there is no default colormap, disable the colorizer
+		if(path == null || texturePack == null) {
+			texturePack = null;
+			return;
+		}
+		
+		// Actually load the colormap
+		this.defaultColor = Colorizers.loadColorData(texturePack, path);
+		if(defaultColor == null) {
+			// If a colormap is found by the first code, but it can't get loaded, throw an Exception
+			throw new NullPointerException("Could not load colormap '" + path + "' from texture pack '" + texturePack.fileName + "'!");
 		}
 	}
 	
-	public ColorMap getColormapForSeason(Season season) {
-		ColorMap colorMap = this.seasonalColormaps.get(season);
-		if(colorMap == null) {
+	public ColorMap loadColormap(Dimension dimension, Season season) {
+		if(season == null || season == Seasons.NULL) {
 			return defaultColor;
 		}
-		return colorMap;
+//		System.out.println("Loading colormap "+this.name+": dimension: " + dimension.languageKey + " season: " + season.getId());
+		
+		String seasonName = season.getId().replace('.', '_').toLowerCase();
+		String seasonPath = "/assets/minecraft/textures/colormap/" + this.name + "/" + seasonName + ".png";
+		
+		ColorMap seasonColor = Colorizers.loadColorData(texturePack, seasonPath);
+//		System.out.println(seasonPath + ": " + seasonColor);
+		if(seasonColor != null) {
+//			System.out.println("  Using season colors!");
+			return seasonColor;
+		}
+		
+//		System.out.println("  Using default colors!");
+		return defaultColor;
 	}
 	
-	public void update(Season season) {
-		ColorMap seasonColors = getColormapForSeason(season);
+	public void update(Dimension dimension, Season season1, Season season2, float blendFactor) {
+		if(!isEnabled()) {
+			return;
+		}
+		
+		ColorMap colorMap1 = loadColormap(dimension, season1);
+		ColorMap colorMap2 = loadColormap(dimension, season2);
+		
+		if(colorMap1 == colorMap2) {
+			update(colorMap1);
+		}else {
+			update(colorMap1, colorMap2, blendFactor);	
+		}
+	}
+	
+	public void update(ColorMap colorMap) {
 		for(int i=0; i < currentColor.buffer.length; i++) {
-			currentColor.buffer[i] = seasonColors.buffer[i];
+			currentColor.buffer[i] = colorMap.buffer[i];
 		}
 	}
 	
-	public void update(Season season1, Season season2, float blendFactor) {
-		ColorMap seasonColors1 = getColormapForSeason(season1);
-		ColorMap seasonColors2 = getColormapForSeason(season2);
-		
+	public void update(ColorMap colorMap1, ColorMap colorMap2, float blendFactor) {
 		for(int i=0; i < currentColor.buffer.length; i++) {
-			currentColor.buffer[i] = blendColor(seasonColors1.buffer[i], seasonColors2.buffer[i], blendFactor);
+			currentColor.buffer[i] = blendColor(colorMap1.buffer[i], colorMap2.buffer[i], blendFactor);
 		}
 	}
 	
 	public int getDefaultColor(double temperature, double humidity) {
-		if(!enabled) {
+		if(!isEnabled()) {
 			return 0xFFFFFFFF;
 		}
 		
@@ -81,7 +112,7 @@ public class Colorizer {
 	}
 	
 	public int getColor(WorldSource world, int x, int y, int z) {
-		if(!enabled) {
+		if(!isEnabled()) {
 			return 0xFFFFFFFF;
 		}
 		
@@ -92,7 +123,7 @@ public class Colorizer {
 	}
 	
 	public int getColor(double temperature, double humidity) {
-		if(!enabled) {
+		if(!isEnabled()) {
 			return 0xFFFFFFFF;
 		}
 		
@@ -100,7 +131,11 @@ public class Colorizer {
 	}
 	
 	public boolean isEnabled() {
-		return enabled;
+		return texturePack != null;
+	}
+	
+	public TexturePack getTexturePack() {
+		return texturePack;
 	}
 	
 	public static int blendColor(int color1, int color2, float blend) {
